##############
# LASSO TEST #
##############
###################################################################
# MAKE SURE THAT YOU CHANGE ALL THE FOLLOWING PATHS APPROPRIATELY #
###################################################################
setup.directory = '/Users/mattiaciollaro/Documents/MATLAB/cvx' # this is where cvx_setup.m is located
path.to.matlab = '/Applications/MATLAB_R2014b.app/bin/matlab' # this is where matlab is located

load( '/Users/mattiaciollaro/Desktop/HW1_Q4/LASSO_data.RData' )

X = LASSOdata$X
y = LASSOdata$y
p = dim( X )[2]
lambdas = LASSOdata$lambdas

##################################################################################################################
cvx.code.lasso = # YOUR CVXfromR HERE (name the optimization variable 'b' for convenience: if you name it 'beta', 
# that can create a conflict with a MATLAB built-in function)

lasso = # YOUR CALL TO THE CallCVX.varyparam FUNCTION HERE
##################################################################################################################

# create a matrix with estimated coefficients for each value of lambda (arranged in columns)
B = do.call( rbind, lasso$b )

ylim.lasso=range( B )
plot( lambdas[1:20], B[1:20,1], type='l', xlab='lambda', ylab='b', main='LASSO paths',ylim=ylim.lasso )
abline( h=0, lty=2 )
for( i in 2:dim( B )[2] ){
	
	lines( lambdas[1:20], B[1:20,i] )
	
}

# function to compute the MSE
MSE.function = function( b.true, b.hat ){
	
	mse = mean( ( b.true - b.hat )^2 )
	
	return( mse )
	
}

# compute the MSE for every value of beta
b.true = LASSOdata$b.gnd
MSE = apply( B, 1, MSE.function, b.true=b.true )

# plot the MSE curve
plot( lambdas, MSE, type='o', main='Lasso - Mean Squared Error', xlab=expression( lambda ), ylab='MSE' )