%% TestSVM
% In this script you will be implementing soft margin SVM using CVX

clear all
clc

load SVM_data.mat

[n,p]=size(X);

err=zeros(length(Clist),1);


%%
for i=1:length(Clist)
    
C=Clist(i);    
%
%% solve SVM primal using CVX

% Input:  X,y, C
% Output: beta, beta0, xi.
beta=zeros(p,1);
beta0=0;
xi=zeros(n,1);

% YOUR CVX CODE HERE!






%% solve SVM dual using CVX

% Input:  X, y, C
% Output: alpha.  alpha is an n dimensional column vector
alpha=zeros(n,1);

% YOUR CVX CODE HERE!




% Reconstruct the primal optimal solutions from the dual solution
beta2=X'*(alpha.*y);
idx=find(alpha< C-1e-5 & alpha>1e-5);
beta02=y(idx(1)) - X(idx(1),:)*beta2;




%% Calculate testing misclassification error

yhat=Xtest*beta+beta0>0;
yhat=yhat*2-1;

err(i)=sum(yhat.*ytest<0)/n;
end



%% Plot figures.

% Plot the decision boundary of the primal
figure(1)
hold off
plot(X(y==-1,1),X(y==-1,2),'xr',...
    X(y==1,1),X(y==1,2),'ob');
hold on
xx=-1:0.1:4;
yy=-(xx*beta(1)+beta0)/beta(2);
plot(xx,yy,'k');



%plot the decision boundary of the dual
figure(2)
hold off
plot(X(y==-1,1),X(y==-1,2),'xr',...
    X(y==1,1),X(y==1,2),'ob');
hold on
xx=-1:0.1:4;
yy=-(xx*beta2(1)+beta02)/beta2(2);
plot(xx,yy,'k');
% along with the support vectors
plot(X(idx,1),X(idx,2),'k.')

% The separating hyper planes should be the same!

% Plot the test error against tuning parameter in log scale
figure(3)
semilogx(Clist,err,'-*');

